#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <basictypes.h>
#include <utils.h>
#include <ucos.h>
#include "ioboardrtc.h"
#include "..\MOD5282\system\sim5282.h"



/* Functions to implement Time */
/* The following two functions are all you need to implment time if you have some method of setting time */
static time_t TimeOffset;

time_t time(time_t * pt)
{
	time_t tv=Secs+TimeOffset;
    if (pt) *pt=tv;
 return tv;
}


time_t set_time(time_t time_to_set)
{
	TimeOffset=time_to_set-Secs;
	time_t tv=Secs+TimeOffset;
 return tv;
}





#define I2C_OK (0)
#define I2C_FAIL (-1)
BYTE i2cbuf[256];


void I2CInit(int slave_Addr,int freqdiv)
{
volatile BYTE bv;
sim.gpio.paspar|=0x0f;
sim.i2c.adr=slave_Addr;
sim.i2c.fdr=freqdiv;
sim.i2c.cr=0x0;
sim.i2c.cr=0xA;
bv=sim.i2c.dr;
sim.i2c.sr=0x0;
sim.i2c.cr=0x0;
OSTimeDly(1);
sim.i2c.cr=0xB0; /* 10110100 */
OSTimeDly(1);
sim.i2c.cr=0x90; /* 10110100 */
OSTimeDly(1);
sim.i2c.sr=0x12;
OSTimeDly(1);
sim.i2c.sr=0x0;
OSTimeDly(1);
}

int I2CSend(BYTE val,DWORD ticks_to_wait)
{
sim.i2c.dr=val;
while ((sim.i2c.sr & 0x2)==0)
{
 OSTimeDly(1);
 ticks_to_wait--;
 if (ticks_to_wait==0) return I2C_FAIL;
}
sim.i2c.sr=0x0;
return I2C_OK;

}



int I2CStart(BYTE addr,DWORD ticks_to_wait)
{

while (sim.i2c.sr & 0x20)
{
 OSTimeDly(1);
 ticks_to_wait--;
 if (ticks_to_wait==0) 
	 {
	  return I2C_FAIL; 
	 }
}

sim.i2c.cr=0xB0;
sim.i2c.sr=0x0;
return I2CSend(addr,ticks_to_wait);
}



int I2CStop()
{
sim.i2c.cr&=0xDF;
return I2C_OK;
}




int I2CRestart(BYTE addr, DWORD ticks_to_wait)
{
sim.i2c.cr|=0x04;

while ((sim.i2c.sr & 0x20)==0)
{
 OSTimeDly(1);
 ticks_to_wait--;
 if (ticks_to_wait==0) 
	 {
	  return I2C_FAIL;
	 }
}

sim.i2c.sr=0x0;

return I2CSend(addr,ticks_to_wait);
}

int I2CRead(PBYTE rx_buffer, int count,DWORD ticks_to_wait)
{
int n=0;
volatile BYTE bv;


sim.i2c.cr=0xA0;  /*10100000 */

bv=sim.i2c.dr;

while(count)
{

 if (count == 1) sim.i2c.cr|=0x08; 

 
 while ((sim.i2c.sr & 0x2)==0)
 {
  OSTimeDly(1);
  ticks_to_wait--;
  if (ticks_to_wait==0) return -n;
 }

sim.i2c.sr=0x0;
bv=sim.i2c.dr;
rx_buffer[n++]=bv;
OSTimeDly(1);
 count--;
}
sim.i2c.cr&=~0x08; 
return n;
}





BYTE MakeBCD(int i)
{
BYTE bv=i % 10;
bv|=((i/10)%10)*16;
return bv;
}

int GetBCD(BYTE bv)
{
int i=bv & 0x0F;
i+=10*((bv>>4)&0x0f);
return i;
}


int IOBoardRTCGetTime(struct tm & bts)
{BYTE Read_buffer[10];
	I2CStart(0xDE,20);
	I2CSend(0x00,20);
	I2CSend(0x30,20);
	I2CRestart(0xDF,20);
	I2CRead(Read_buffer,8,20);
	I2CStop();


bts.tm_sec=GetBCD(Read_buffer[0]);
bts.tm_min=GetBCD(Read_buffer[1]); 
bts.tm_hour=GetBCD(Read_buffer[2]& 0x7F); 
bts.tm_mday=GetBCD(Read_buffer[3]); 
bts.tm_mon=GetBCD(Read_buffer[4])-1; 
bts.tm_year=GetBCD(Read_buffer[5])+100; 
bts.tm_wday=GetBCD(Read_buffer[6]); 

return 0;
}



int IOBoardRTCSetTime(struct tm & bts)
{

I2CInit(0,0x12);
I2CStop();

OSTimeDly(1);
I2CStart(0xDE,20);
I2CSend(0x00,20);
I2CSend(0x3F,20);
I2CSend(0x02,20); /* Set SR reg to 02 */
I2CStop();
OSTimeDly(1);

I2CStart(0xDE,20);
I2CSend(0x00,20);
I2CSend(0x3F,20);
I2CSend(0x06,20); /* Set SR Reg to 06 */
I2CStop();
OSTimeDly(1);

I2CStart(0xDE,20);
I2CSend(0x00,20);
I2CSend(0x30,20); 
I2CSend(MakeBCD(bts.tm_sec),20); /* Seconds */ 
I2CSend(MakeBCD(bts.tm_min),20); /* Minutes */ 
I2CSend(MakeBCD(bts.tm_hour)+0x80,20); /* Hour */    
I2CSend(MakeBCD(bts.tm_mday),20); /* Day  */    
I2CSend(MakeBCD(bts.tm_mon+1),20); /* Month */   
I2CSend(MakeBCD(bts.tm_year % 100),20); /* Year */    
I2CSend(MakeBCD(bts.tm_wday),20); /* Day of week */
I2CSend(0x20,20); /* Y2k */
I2CStop();

return 0;
}


int IOBoardRTCSetSystemFromRTCTime()
{
struct tm bts;
int rv=IOBoardRTCGetTime(bts);
if (rv) return rv;
time_t t=mktime(&bts);
set_time(t);
return 0;
}


int IOBoardRTCSetRTCfromSystemTime()
{
time_t t=time(NULL);
struct tm * ptm=gmtime(&t);
return IOBoardRTCSetTime(*ptm); 
}


